/**
 * @version 1.0 2004-06-1
 * @author Gonzalo Ojeda 9821018-0
 */

import java.io.*;
import java.util.*;

/**
 * Clase utilizada para escribir las figuras, al archivo ".fig" con el formato
 * Fig3.2
 */
public class FigWrite
{
   /**
    * Constructor de la clase, escribe al archivo una primera parte que para
    * las necesidades de la tarea siempre se mantiene constante, y llama a un
    * metodo que escribe cada una de las figuras al archivo ".fig"
    * @param name corresponde al nombre del archivo a escribir (.fig)
    * @param formas Arraylist de las Formas (no Shapes).
    */
   public FigWrite (String name, ArrayList formas)
   {
      //archivo de salida
      File outputFile = new File(name);
      // bucle para escribir al archivo, captura la excepcin si no puede
      try
      {
         FileWriter out = new FileWriter(outputFile);
         // escribe la primera parte del archivo
         writeIni(out);
         // escribe cada una de las figuras al archivo
         for (int i = 0; i < formas.size(); i++)
         {
            actual = (Formas)formas.get(i);
            actual.writeForma(out);
         }
         out.close();                  // cierra el FileWriter
      }
      catch (IOException e) 
         {
            e.printStackTrace();
         }
   }

   /**
    * Mtodo que escribe al archivo una ".fig" primera parte que para
    * las necesidades de la tarea siempre se mantiene constante
    * @param out FileWriter para poder escribir en el mismo archivo
    */
   void writeIni(FileWriter out) throws IOException
   {
      out.write("#FIG 3.2\n");
      out.write("Portrait\n");
      out.write("Center\n");
      out.write("Metric\n");
      out.write("A4\n");
      out.write("100.0\n");
      out.write("Single\n");
      out.write("-2\n");
      out.write("80 2");
   }

   // para poder leer de ArrayList y llamar al mtodo writeForma().
   private Formas actual;
}
